﻿Imports System
Imports System.Collections.Generic
Imports System.Windows.Forms
Imports AutoDialer.AutoDialer

Partial Public Class MainForm
        Inherits Form

        Private m_objServerExCOM As cVaxServerExCOM
        Private m_nPhoneNoId As UInt32
        Private m_nConcurrentCallCount As Integer

        Public Sub New()
            m_objServerExCOM = New cVaxServerExCOM(Me)
            Dim epoch As DateTime = New DateTime(1970, 1, 1)
            Dim obj As DateTime = epoch.AddSeconds(8)
            Dim sTime As String = String.Format("{0}:{1}:{2}", obj.Hour, obj.Minute, obj.Second)
            m_nPhoneNoId = 0
            m_nConcurrentCallCount = 0
            InitializeComponent()
            Dim nLineType As Integer = cVaxServerCOM.VAX_LINE_TYPE_UDP
            Dim sDisplayName As String = "", sUserName As String = ""
            Dim sAuthUser As String = "", sAuthPwd As String = ""
            Dim sDomainRealm As String = "", sServerAddr As String = ""
            Dim nServerPort As Integer = 5060
            cStoreLine.GetLine(cVaxServerExCOM.VAX_ACCOUNT_LINE_SIP, nLineType, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sServerAddr, nServerPort)
            EditDisplayName.Text = sDisplayName
            EditUserName.Text = sUserName
            EditAuthName.Text = sAuthUser
            EditPassword.Text = sAuthPwd
            EditDomain.Text = sDomainRealm
            EditServerAddr.Text = sServerAddr
            EditServerPort.Text = Convert.ToString(nServerPort)
            Dim nListenPortSIP As Integer = cStoreCOMM.GetListenPortSIP()
            EditListenPort.Text = nListenPortSIP.ToString()
        End Sub

    Private Sub btnStartServer_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStartServer.Click
        m_objServerExCOM.SetLicenseKey("TRIAL-LICENSE-KEY")
        Dim bStatusRun As Boolean = m_objServerExCOM.Initialize(Convert.ToInt32(EditListenPort.Text))

        If bStatusRun = False Then
            LabelServerStatus.Text = "UNABLE TO START SIP SERVER (SEE ERROR LOG)."
            Return
        End If

        If check_DiagnosticLog.Checked Then m_objServerExCOM.DiagnosticLogSIP(True, True)
        cStoreCOMM.SetListenPortSIP(Convert.ToInt32(EditListenPort.Text))
        TimerCallCount.Enabled = True
        LabelServerStatus.Text = "SIP SERVER AUTO DIALER IS RUNNING."
    End Sub

    Private Sub btnStop_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStop.Click
        TimerCallCount.Enabled = False
        m_objServerExCOM.UnInitialize()
        LabelServerStatus.Text = "SIP SERVER AUTO DIALER IS NOT RUNNING."
        LabelTotalCalls.Text = "0"
        btnRegisterAccountSIP.Text = "Online"
    End Sub

    Private Sub btnRegisterAccountSIP_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnRegisterAccountSIP.Click
        If Not m_objServerExCOM.IsInitialized() Then
            MessageBox.Show("Please click the start button first.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        If m_objServerExCOM.IsAddedAccountSIP() Then
            m_objServerExCOM.UnRegisterAccountSIP()
            btnRegisterAccountSIP.Text = "Online"
            Return
        End If

        If Not m_objServerExCOM.RegisterAccountSIP(EditDisplayName.Text, EditUserName.Text, EditAuthName.Text, EditPassword.Text, EditDomain.Text, EditServerAddr.Text, (Convert.ToInt32(EditServerPort.Text))) Then Return
        cStoreLine.AddLine(cVaxServerExCOM.VAX_ACCOUNT_LINE_SIP, cVaxServerCOM.VAX_LINE_TYPE_UDP, EditDisplayName.Text, EditUserName.Text, EditAuthName.Text, EditPassword.Text, EditDomain.Text, EditServerAddr.Text, Convert.ToInt32(EditServerPort.Text))
        btnRegisterAccountSIP.Text = "Offline"
    End Sub

    Private Sub TimerGeneral_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles TimerCallCount.Tick
        LabelTotalCalls.Text = m_objServerExCOM.GetCallCount().ToString()
    End Sub

    Public Sub OnVaxStatusLog(ByVal sMsg As String)
        ListStatus.Items.Add(sMsg)
        ListStatus.TopIndex = ListStatus.Items.Count - 1
    End Sub

    Public Sub OnPhoneNoStatusLog(ByVal nPhoneNoId As UInt32, ByVal sPhoneNo As String, ByVal sStatus As String, ByVal sDigitDTMF As String, ByVal sDuration As String)
        UpdateListItem(nPhoneNoId, sPhoneNo, sStatus, sDigitDTMF, sDuration)
    End Sub

    Private Sub btnClearLog_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClearLog.Click
        ListStatus.Items.Clear()
    End Sub

    Private Sub btn_StartAutoDialer_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_StartAutoDialer.Click
        If Not m_objServerExCOM.IsAddedAccountSIP() Then
            MessageBox.Show("SIP account is not added or registered.", "VaxVoIP SIP SDK", MessageBoxButtons.OK)
            Return
        End If

        If btn_StartAutoDialer.Text = "Stop Dialing" Then
            TimerAutoDialer.Enabled = False
            btn_StartAutoDialer.Text = "Start Dialing"
            Return
        End If

        m_nConcurrentCallCount = Convert.ToInt32(EditConcurrentCalls.Text)
        TimerAutoDialer.Enabled = True
        m_objServerExCOM.LoadMusicAutoDialer(EditWaveFileDialer.Text)
        m_objServerExCOM.EnableDetectDTMF(check_DetectDTMF.Checked)
        m_objServerExCOM.EnableDetectAMD(check_DetectAMD.Checked)
        m_objServerExCOM.SetPlayWaveConnected(check_PlayWave.Checked)
        btn_StartAutoDialer.Text = "Stop Dialing"
    End Sub

    Private Sub InsertListItem(ByVal sPhoneNo As String, ByVal sPhoneStatus As String, ByVal sDigitDTMF As String, ByVal sDuration As String)
        sPhoneNo.Trim()
        sPhoneStatus.Trim()
        listView_PhoneNo.Items.Add(New cListViewItemEx(m_nPhoneNoId, sPhoneNo, sPhoneStatus, sDigitDTMF, sDuration))
        m_nPhoneNoId += 1
        listView_PhoneNo.TopItem = listView_PhoneNo.Items(listView_PhoneNo.Items.Count - 1)
    End Sub

    Private Sub UpdateListItem(ByVal nPhoneNoId As UInt32, ByVal sPhoneNo As String, ByVal sPhoneStatus As String, ByVal sDigitDTMF As String, ByVal sDuration As String)
        For Each LVitem As ListViewItem In listView_PhoneNo.Items

            If (CType(LVitem, cListViewItemEx)).m_nPhoneNoId = nPhoneNoId Then
                If sPhoneStatus.Length <> 0 Then LVitem.SubItems(1).Text = sPhoneStatus
                If sDigitDTMF.Length <> 0 Then LVitem.SubItems(2).Text = sDigitDTMF
                If sDuration.Length <> 0 Then LVitem.SubItems(3).Text = sDuration
                Exit For
            End If
        Next
    End Sub

    Private Sub btnAddPhoneNo_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnAddPhoneNo.Click
        If EditPhoneNo.Text.Length = 0 Then Return
        InsertListItem(EditPhoneNo.Text, cDefine.PHONE_NO_WAITING, "", "")
    End Sub

    Private Sub TimerAutoDialer_Tick(sender As Object, e As EventArgs) Handles TimerAutoDialer.Tick
        If listView_PhoneNo.Items.Count = 0 Then Return
        If m_objServerExCOM.GetCallCount() >= m_nConcurrentCallCount Then Return

        For Each LVitem As ListViewItem In listView_PhoneNo.Items
            If LVitem.SubItems(1).Text <> cDefine.PHONE_NO_WAITING Then Continue For
            Dim sPhoneNo As String = LVitem.SubItems(0).Text
            If sPhoneNo.Length = 0 Then Exit For
            m_objServerExCOM.DialCall(sPhoneNo, (CType(LVitem, cListViewItemEx)).m_nPhoneNoId)
            Exit For
        Next
    End Sub

    Private Sub btn_LoadCSV_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_LoadCSV.Click
        openFileDlgCSV.Filter = "CSV Files |*.csv"
        Dim result As DialogResult = openFileDlgCSV.ShowDialog()

        If result <> DialogResult.OK Then
            Return
        End If

        Dim sLoadFileName As String = openFileDlgCSV.FileName
        If sLoadFileName.Length = 0 Then Return
        Dim objListPhoneNo As List(Of String) = New List(Of String)()
        Dim objListPhoneStatus As List(Of String) = New List(Of String)()
        Dim objListDTMF As List(Of String) = New List(Of String)()
        Dim objListDuration As List(Of String) = New List(Of String)()
        Dim objFileCSV As cFileCSV = New cFileCSV(sLoadFileName)
        If Not objFileCSV.GetDataCSV(objListPhoneNo, objListPhoneStatus, objListDTMF, objListDuration) Then Return
        If objListPhoneNo.Count <> objListPhoneStatus.Count Then Return

        For nIndex As Integer = 0 To objListPhoneNo.Count - 1
            InsertListItem(objListPhoneNo(nIndex), objListPhoneStatus(nIndex), objListDTMF(nIndex), objListDuration(nIndex))
        Next
    End Sub

    Private Sub btn_RemoveListRecord_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_RemoveListRecord.Click
        For Each LVitem As ListViewItem In listView_PhoneNo.SelectedItems
            m_objServerExCOM.CloseCall((CType(LVitem, cListViewItemEx)).m_nPhoneNoId)
            listView_PhoneNo.Items.Remove(LVitem)
        Next
    End Sub

    Private Sub btn_SaveDialerResult_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_SaveDialerResult.Click
        saveFileDlgCSV.Filter = "CSV Files |*.csv"
        saveFileDlgCSV.FileName = "PhoneNo.CSV"
        Dim result As DialogResult = saveFileDlgCSV.ShowDialog()
        If result <> DialogResult.OK Then Return
        Dim sFileNameCSV As String = saveFileDlgCSV.FileName
        If sFileNameCSV.Length = 0 Then Return
        Dim objListPhoneNo As List(Of String) = New List(Of String)()
        Dim objListPhoneStatus As List(Of String) = New List(Of String)()
        Dim objListDTMF As List(Of String) = New List(Of String)()
        Dim objListDuration As List(Of String) = New List(Of String)()

        For Each LVitem As ListViewItem In listView_PhoneNo.Items
            If LVitem.SubItems(0).Text.Length = 0 Then LVitem.SubItems(0).Text = "  "
            If LVitem.SubItems(1).Text.Length = 0 Then LVitem.SubItems(1).Text = "  "
            If LVitem.SubItems(2).Text.Length = 0 Then LVitem.SubItems(2).Text = "  "
            If LVitem.SubItems(3).Text.Length = 0 Then LVitem.SubItems(3).Text = "  "
            objListPhoneNo.Add(LVitem.SubItems(0).Text)
            objListPhoneStatus.Add(LVitem.SubItems(1).Text)
            objListDTMF.Add(LVitem.SubItems(2).Text)
            objListDuration.Add(LVitem.SubItems(3).Text)
        Next

        Dim objFileCSV As cFileCSV = New cFileCSV(sFileNameCSV)
        If Not objFileCSV.WriteDataCSV(objListPhoneNo, objListPhoneStatus, objListDTMF, objListDuration) Then Return
    End Sub

    Private Sub btn_LoadWave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_LoadWavePath.Click
        openFileDlgCSV.Filter = "Wav Files |*.wav"
        Dim result As DialogResult = openFileDlgCSV.ShowDialog()
        If result <> DialogResult.OK Then Return
        EditWaveFileDialer.Text = openFileDlgCSV.FileName
    End Sub

    Private Sub check_DiagnosticLog_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles check_DiagnosticLog.CheckedChanged
        If check_DiagnosticLog.Checked Then
            m_objServerExCOM.DiagnosticLogSIP(True, True)
        Else
            m_objServerExCOM.DiagnosticLogSIP(False, False)
        End If
    End Sub

    Private Sub check_DetectAMD_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles check_DetectAMD.CheckedChanged
        m_objServerExCOM.EnableDetectAMD(check_DetectAMD.Checked)
    End Sub

    Private Sub check_DetectDTMF_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles check_DetectDTMF.CheckedChanged
        m_objServerExCOM.EnableDetectDTMF(check_DetectDTMF.Checked)
    End Sub

    Private Sub BtnDemoAccount_Click(sender As Object, e As EventArgs) Handles BtnDemoAccount.Click

        Dim EpocTime As TimeSpan = DateTime.UtcNow - New DateTime(1970, 1, 1)
        Dim nEpocSeconds As Integer = CInt(EpocTime.TotalSeconds) Mod 9999999

        Dim sAccountDemo As String = nEpocSeconds.ToString()

        EditAuthName.Text = sAccountDemo
        EditPassword.Text = sAccountDemo

        EditDisplayName.Text = sAccountDemo
        EditUserName.Text = sAccountDemo

        EditDomain.Text = "demo.vaxvoip.com"

        EditServerAddr.Text = "demo.vaxvoip.com"
        EditServerPort.Text = "8060"

        Dim sDemoMsg As String = ""

        sDemoMsg = vbCrLf & "Auth Login: " & sAccountDemo & vbCrLf
        sDemoMsg &= "Auth Password: " & sAccountDemo & vbCrLf
        sDemoMsg &= "Server Addr: " & EditServerAddr.Text & vbCrLf
        sDemoMsg &= "Server Port: " & EditServerPort.Text & vbCrLf & vbCrLf

        MessageBox.Show(sDemoMsg & "Demo accounts are only for account-to-account VoIP calls. Use demo accounts on different devices to dial/receive VoIP calls." & vbCrLf & vbCrLf & "Dial 000 for self testing." & vbCrLf & vbCrLf & "[Powered by VaxVoIP Server SDK]", "VaxVoIP SDK", MessageBoxButtons.OK, MessageBoxIcon.Information)

    End Sub

End Class

