﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Speech.Synthesis
Imports System.Speech.AudioFormat
Imports System.IO
Imports Microsoft

Namespace AutoDialer

    Public Class cTextToSpeech
        Public Sub New()
        End Sub

        Public Sub GenSpeech(ByVal sText As String, ByRef aDataPCM As Byte(), ByRef nDataSize As Integer)

            Dim hSynthesizer As SpeechSynthesizer = New SpeechSynthesizer()
            Dim hbuilder As PromptBuilder = New PromptBuilder()
            Dim hStyle As PromptStyle = New PromptStyle()

            hStyle.Emphasis = PromptEmphasis.None
            hStyle.Rate = PromptRate.Fast
            hStyle.Volume = PromptVolume.ExtraLoud

            hbuilder.StartStyle(hStyle)
            hbuilder.StartParagraph()
            hbuilder.StartVoice(VoiceGender.Male, VoiceAge.Teen, 2)
            hbuilder.StartSentence()
            hbuilder.AppendText(sText)
            hbuilder.EndSentence()
            hbuilder.EndVoice()
            hbuilder.EndParagraph()
            hbuilder.EndStyle()

            Dim hSynthFormat As SpeechAudioFormatInfo = New SpeechAudioFormatInfo(8000, AudioBitsPerSample.Sixteen, AudioChannel.Mono)
            Dim hStreamMem As MemoryStream = New MemoryStream()

            hSynthesizer.SetOutputToAudioStream(hStreamMem, hSynthFormat)
            hSynthesizer.Speak(hbuilder)
            hSynthesizer.SetOutputToNull()

            hStreamMem.Position = 0
            nDataSize = hStreamMem.Length

            aDataPCM = New Byte(nDataSize) {}
            Array.Copy(hStreamMem.ToArray(), aDataPCM, nDataSize)

        End Sub
    End Class

End Namespace
