﻿Imports System
Imports System.Collections.Generic
Imports System.Windows.Forms
Imports BasicIVR.BasicIVR

Partial Public Class MainForm
    Inherits Form

    Private m_objServerExCOM As cVaxServerExCOM
    Private m_nPhoneNoId As UInt32

    Public Sub New()
        m_objServerExCOM = New cVaxServerExCOM(Me)
        Dim epoch As DateTime = New DateTime(1970, 1, 1)
        Dim obj As DateTime = epoch.AddSeconds(8)
        Dim sTime As String = String.Format("{0}:{1}:{2}", obj.Hour, obj.Minute, obj.Second)
        m_nPhoneNoId = 0
        InitializeComponent()
        Dim nLineType As Integer = cVaxServerCOM.VAX_LINE_TYPE_UDP
        Dim sDisplayName As String = "", sUserName As String = ""
        Dim sAuthUser As String = "", sAuthPwd As String = ""
        Dim sDomainRealm As String = "", sServerAddr As String = ""
        Dim nServerPort As Integer = cVaxServerCOM.SIP_DEFAULT_PORT
        cStoreLine.GetLine(cVaxServerExCOM.VAX_ACCOUNT_LINE_SIP, nLineType, sDisplayName, sUserName, sAuthUser, sAuthPwd, sDomainRealm, sServerAddr, nServerPort)
        EditDisplayName.Text = sDisplayName
        EditUserName.Text = sUserName
        EditAuthName.Text = sAuthUser
        EditPassword.Text = sAuthPwd
        EditDomain.Text = sDomainRealm
        EditServerAddr.Text = sServerAddr
        EditServerPort.Text = Convert.ToString(nServerPort)
        Dim nListenPortSIP As Integer = cStoreCOMM.GetListenPortSIP()
        EditListenPort.Text = nListenPortSIP.ToString()
    End Sub

    Private Sub btnStartServer_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStartServer.Click
        Dim bStatusRun As Boolean = m_objServerExCOM.Initialize(Convert.ToInt32(EditListenPort.Text))

        If bStatusRun = False Then
            LabelServerStatus.Text = "UNABLE TO START SIP SERVER IVR (SEE ERROR LOG)."
            Return
        End If

        If check_DiagnosticLog.Checked Then m_objServerExCOM.DiagnosticLogSIP(True, True)
        m_objServerExCOM.LoadMusic(EditPlayWaveFile.Text)
        cStoreCOMM.SetListenPortSIP(Convert.ToInt32(EditListenPort.Text))
        TimerCallCount.Enabled = True
        LabelServerStatus.Text = "SIP SERVER IVR IS RUNNING."
    End Sub

    Private Sub btnStop_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnStop.Click
        TimerCallCount.Enabled = False
        m_objServerExCOM.UnInitialize()
        LabelServerStatus.Text = "SIP SERVER IVR IS NOT RUNNING."
        LabelTotalCalls.Text = "0"
        btnRegisterAccountSIP.Text = "Register"
    End Sub

    Private Sub btnRegisterAccountSIP_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnRegisterAccountSIP.Click
        If Not m_objServerExCOM.IsInitialized() Then
            MessageBox.Show("Please click the start button first.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        If m_objServerExCOM.IsAddedAccountSIP() Then
            m_objServerExCOM.UnRegisterAccountSIP()
            btnRegisterAccountSIP.Text = "Register"
            Return
        End If

        If Not m_objServerExCOM.RegisterAccountSIP(EditDisplayName.Text, EditUserName.Text, EditAuthName.Text, EditPassword.Text, EditDomain.Text, EditServerAddr.Text, (Convert.ToInt32(EditServerPort.Text))) Then Return
        cStoreLine.AddLine(cVaxServerExCOM.VAX_ACCOUNT_LINE_SIP, cVaxServerCOM.VAX_LINE_TYPE_UDP, EditDisplayName.Text, EditUserName.Text, EditAuthName.Text, EditPassword.Text, EditDomain.Text, EditServerAddr.Text, Convert.ToInt32(EditServerPort.Text))
        btnRegisterAccountSIP.Text = "UnRegister"
    End Sub

    Private Sub TimerCallCount_Tick(sender As Object, e As EventArgs) Handles TimerCallCount.Tick
        LabelTotalCalls.Text = m_objServerExCOM.GetCallCount().ToString()
    End Sub

    Public Sub OnVaxStatusLog(ByVal sMsg As String)
        ListStatus.Items.Add(sMsg)
        ListStatus.TopIndex = ListStatus.Items.Count - 1
    End Sub

    Public Sub OnPhoneNoStatusLog(ByVal nPhoneNoId As UInteger, ByVal sPhoneNo As String, ByVal sStatus As String, ByVal sDigitDTMF As String, ByVal sDuration As String, ByVal sRecordFile As String)
        UpdateListItem(nPhoneNoId, sPhoneNo, sStatus, sDigitDTMF, sDuration, sRecordFile)
    End Sub

    Private Sub btnClearLog_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClearLog.Click
        ListStatus.Items.Clear()
    End Sub

    Public Function InsertListItem(ByVal sPhoneNo As String, ByVal sPhoneStatus As String, ByVal sDigitDTMF As String, ByVal sDuration As String, ByVal sRecordFile As String) As UInteger
        sPhoneNo.Trim()
        sPhoneStatus.Trim()
        m_nPhoneNoId += 1
        listView_PhoneNo.Items.Add(New cListViewItemEx(m_nPhoneNoId, sPhoneNo, sPhoneStatus, sDigitDTMF, sDuration, sRecordFile))
        listView_PhoneNo.TopItem = listView_PhoneNo.Items(listView_PhoneNo.Items.Count - 1)
        Return m_nPhoneNoId
    End Function

    Private Sub UpdateListItem(ByVal nPhoneNoId As UInteger, ByVal sPhoneNo As String, ByVal sPhoneStatus As String, ByVal sDigitDTMF As String, ByVal sDuration As String, ByVal sRecordFile As String)
        For Each LVitem As ListViewItem In listView_PhoneNo.Items

            If (CType(LVitem, cListViewItemEx)).m_nPhoneNoId = nPhoneNoId Then
                If sPhoneStatus.Length <> 0 Then LVitem.SubItems(1).Text = sPhoneStatus
                If sDigitDTMF.Length <> 0 Then LVitem.SubItems(2).Text = sDigitDTMF
                If sDuration.Length <> 0 Then LVitem.SubItems(3).Text = sDuration
                If sRecordFile.Length <> 0 Then LVitem.SubItems(4).Text = sRecordFile
                Exit For
            End If
        Next
    End Sub

    Private Sub btn_LoadCSV_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_LoadCSV.Click
        openFileDlgCSV.Filter = "CSV Files |*.csv"
        Dim result As DialogResult = openFileDlgCSV.ShowDialog()

        If result <> DialogResult.OK Then
            Return
        End If

        Dim sLoadFileName As String = openFileDlgCSV.FileName
        If sLoadFileName.Length = 0 Then Return
        Dim objListPhoneNo As List(Of String) = New List(Of String)()
        Dim objListPhoneStatus As List(Of String) = New List(Of String)()
        Dim objListDTMF As List(Of String) = New List(Of String)()
        Dim objListDuration As List(Of String) = New List(Of String)()
        Dim objListRecordFile As List(Of String) = New List(Of String)()
        Dim objFileCSV As cFileCSV = New cFileCSV(sLoadFileName)
        If Not objFileCSV.GetDataCSV(objListPhoneNo, objListPhoneStatus, objListDTMF, objListDuration, objListRecordFile) Then Return
        If objListPhoneNo.Count <> objListPhoneStatus.Count Then Return

        For nIndex As Integer = 0 To objListPhoneNo.Count - 1
            InsertListItem(objListPhoneNo(nIndex), objListPhoneStatus(nIndex), objListDTMF(nIndex), objListDuration(nIndex), objListRecordFile(nIndex))
        Next
    End Sub

    Private Sub btn_RemoveListRecord_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_RemoveListRecord.Click
        For Each LVitem As ListViewItem In listView_PhoneNo.SelectedItems
            m_objServerExCOM.CloseCall((CType(LVitem, cListViewItemEx)).m_nPhoneNoId)
            listView_PhoneNo.Items.Remove(LVitem)
        Next
    End Sub

    Private Sub btn_SaveResult_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_SaveResult.Click

        saveFileDlgCSV.Filter = "CSV Files |*.csv"
        saveFileDlgCSV.FileName = "PhoneNo.CSV"
        Dim result As DialogResult = saveFileDlgCSV.ShowDialog()
        If result <> DialogResult.OK Then Return
        Dim sFileNameCSV As String = saveFileDlgCSV.FileName
        If sFileNameCSV.Length = 0 Then Return
        Dim objListPhoneNo As List(Of String) = New List(Of String)()
        Dim objListPhoneStatus As List(Of String) = New List(Of String)()
        Dim objListDTMF As List(Of String) = New List(Of String)()
        Dim objListDuration As List(Of String) = New List(Of String)()
        Dim objListRecordFile As List(Of String) = New List(Of String)()

        For Each LVitem As ListViewItem In listView_PhoneNo.Items
            If LVitem.SubItems(0).Text.Length = 0 Then LVitem.SubItems(0).Text = "  "
            If LVitem.SubItems(1).Text.Length = 0 Then LVitem.SubItems(1).Text = "  "
            If LVitem.SubItems(2).Text.Length = 0 Then LVitem.SubItems(2).Text = "  "
            If LVitem.SubItems(3).Text.Length = 0 Then LVitem.SubItems(3).Text = "  "
            If LVitem.SubItems(4).Text.Length = 0 Then LVitem.SubItems(4).Text = "  "
            objListPhoneNo.Add(LVitem.SubItems(0).Text)
            objListPhoneStatus.Add(LVitem.SubItems(1).Text)
            objListDTMF.Add(LVitem.SubItems(2).Text)
            objListDuration.Add(LVitem.SubItems(3).Text)
            objListRecordFile.Add(LVitem.SubItems(4).Text)
        Next

        Dim objFileCSV As cFileCSV = New cFileCSV(sFileNameCSV)
        If Not objFileCSV.WriteDataCSV(objListPhoneNo, objListPhoneStatus, objListDTMF, objListDuration, objListRecordFile) Then Return

    End Sub

    Private Sub btn_LoadWave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_LoadWavePath.Click
        openFileDlgCSV.Filter = "Wav Files |*.wav"
        Dim result As DialogResult = openFileDlgCSV.ShowDialog()
        If result <> DialogResult.OK Then Return
        EditPlayWaveFile.Text = openFileDlgCSV.FileName
    End Sub

    Private Sub check_DiagnosticLog_Click(sender As Object, e As EventArgs) Handles check_DiagnosticLog.Click
        If check_DiagnosticLog.Checked Then
            m_objServerExCOM.DiagnosticLogSIP(True, True)
        Else
            m_objServerExCOM.DiagnosticLogSIP(False, False)
        End If
    End Sub

    Private Sub check_DetectDTMF_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles check_DetectDTMF.Click
        m_objServerExCOM.EnableDetectDTMF(check_DetectDTMF.Checked)
    End Sub

    Private Sub check_PlayWave_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs) Handles check_PlayWave.Click
        m_objServerExCOM.SetPlayWaveConnected(check_PlayWave.Checked)
    End Sub

End Class
