﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Namespace BasicIVR
    Class cVaxCallSession
        Inherits Object

        Public m_nSessionId As Integer
        Public m_sPhoneNo As String

        Public m_sStatus As String
        Public m_nPhoneNoId As UInt32

        Private m_nStartTime As UInt32
        Private m_nEndTime As UInt32

        Private m_nDuration As UInt32
        Private m_bConnected As Boolean

        Private m_objAccessPCM As cVaxAccessAudioPCM
        Private m_objDetectVAD As cVaxDetectAudioVAD

        Public Sub New()

            m_nPhoneNoId = 0
            m_nStartTime = 0
            m_nEndTime = 0

            m_nDuration = 0
            m_bConnected = False

            m_objAccessPCM = New cVaxAccessAudioPCM()
            m_objDetectVAD = New cVaxDetectAudioVAD()

        End Sub

        Public Sub StartCall()
            Dim t As TimeSpan = DateTime.UtcNow - New DateTime(1970, 1, 1)
            m_nStartTime = CUInt(t.TotalSeconds)
        End Sub

        Public Sub EndCall()
            Dim t As TimeSpan = DateTime.UtcNow - New DateTime(1970, 1, 1)
            m_nEndTime = CUInt(t.TotalSeconds)
            m_nDuration = m_nEndTime - m_nStartTime
        End Sub

        Public Function GetDuration() As String

            Dim epoch As DateTime = New DateTime(1970, 1, 1)
            Dim obj As DateTime = epoch.AddSeconds(m_nDuration)

            Dim sHour As String = obj.Hour.ToString()
            Dim sMin As String = obj.Minute.ToString()
            Dim sSec As String = obj.Second.ToString()

            If sHour.Length = 1 Then sHour = "0" & sHour
            If sMin.Length = 1 Then sMin = "0" & sMin
            If sSec.Length = 1 Then sSec = "0" & sSec

            Dim sTime As String = String.Format("{0}:{1}:{2}", sHour, sMin, sSec)
            Return sTime

        End Function

        Public Sub SetConnected()
            m_bConnected = True
        End Sub

        Public Function IsConnected() As Boolean
            Return m_bConnected
        End Function

        '////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionConnected(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
            m_objAccessPCM.OnCallSessionConnected(nSessionId, nChannelId)
            m_objDetectVAD.OnCallSessionConnected(nSessionId, nChannelId)
        End Sub

        Public Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nReasonCode As Integer)
            m_objAccessPCM.OnCallSessionClosed(nSessionId)
            m_objDetectVAD.OnCallSessionClosed(nSessionId)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionAccessAudioPCM(ByVal nSessionId As Integer, ByVal nAccessType As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer)
            m_objAccessPCM.OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionMediaDetectStartedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectStartedVAD(nSessionId, nChannelId)
        End Sub

        Public Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectCompletedVAD(nSessionId, nChannelId, aDataPCM, nSizePCM, nTypePCM)
        End Sub

        Public Sub OnCallSessionMediaDetectExpiredVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectExpiredVAD(nSessionId, nChannelId)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

    End Class

End Namespace
